module.exports = {
  extends: ['react-app'],
  env: {
    browser: true,
    node: true,
    es6: true,
  },
  settings: {
    react: {
      version: 'detect',
    },
    'import/resolver': {
      node: {
        extensions: ['.ts', '.tsx'],
        moduleDirectory: ['node_modules', 'src/'],
      },
    },
  },
  rules: {
    'react-hooks/exhaustive-deps': 0,
    'react/no-unused-prop-types': 2,
    'jsx-a11y/alt-text': [0],
    'require-await': 2,
    indent: 'off',
    'no-mixed-spaces-and-tabs': ['error', 'smart-tabs'],
    'keyword-spacing': ['error', { before: true, after: true }],
    'space-before-blocks': 'error',
    'comma-dangle': [1, 'always-multiline'],
    quotes: ['error', 'single', { avoidEscape: true }],
    'quote-props': ['error', 'as-needed', { numbers: false }],
    'jsx-quotes': ['error', 'prefer-single'],
    'no-console': [1, { allow: ['warn', 'error', 'debug', 'info'] }],
    'no-debugger': 1,
    'arrow-parens': ['error', 'always'],
    'no-useless-escape': 0,
    'no-script-url': 0,
    'no-var': 2,
    'no-restricted-globals': 0,
    'prefer-const': 2,
    'eol-last': 2,
    'max-params': [2, 3],
    'no-trailing-spaces': 2,
    'no-multiple-empty-lines': ['error', { max: 1, maxEOF: 1 }],

    'jsx-a11y/anchor-is-valid': 0,
    'react/no-deprecated': 0,
    'react/jsx-no-duplicate-props': [2, { ignoreCase: false }],
    'react/prop-types': 2,
    'react/display-name': 0,
    'react/no-find-dom-node': 0,
    'react/react-in-jsx-scope': 0,
    'react/no-unused-state': 2,

    'import/no-duplicates': 2,
    'newline-before-return': 2,
    'newline-after-var': 2,
    'import/order': [
      2,
      {
        groups: [
          ['builtin', 'external'],
          'internal',
          'sibling',
          'parent',
          'index',
        ],
        pathGroupsExcludedImportTypes: ['react', 'internal'],
      },
    ],
  },
}
